diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/object.cc ns-3.31/src/core/model/object.cc
--- ns-3.30.1/src/core/model/object.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/object.cc	2020-06-27 17:38:30.000000000 -0700
@@ -104,7 +104,7 @@
   m_aggregates->n = 1;
   m_aggregates->buffer[0] = this;
 }
-Object::~Object () 
+Object::~Object ()
 {
   // remove this object from the aggregate list
   NS_LOG_FUNCTION (this);
@@ -114,9 +114,9 @@
       Object *current = m_aggregates->buffer[i];
       if (current == this)
         {
-          std::memmove (&m_aggregates->buffer[i], 
-                   &m_aggregates->buffer[i+1],
-                   sizeof (Object *)*(m_aggregates->n - (i+1)));
+          std::memmove (&m_aggregates->buffer[i],
+                        &m_aggregates->buffer[i + 1],
+                        sizeof (Object *) * (m_aggregates->n - (i + 1)));
           m_aggregates->n--;
         }
     }
@@ -186,8 +186,8 @@
    * Note: the code here is a bit tricky because we need to protect ourselves from
    * modifications in the aggregate array while DoInitialize is called. The user's
    * implementation of the DoInitialize method could call GetObject (which could
-   * reorder the array) and it could call AggregateObject which would add an 
-   * object at the end of the array. To be safe, we restart iteration over the 
+   * reorder the array) and it could call AggregateObject which would add an
+   * object at the end of the array. To be safe, we restart iteration over the
    * array whenever we call some user code, just in case.
    */
   NS_LOG_FUNCTION (this);
@@ -210,13 +210,13 @@
   NS_LOG_FUNCTION (this);
   return m_initialized;
 }
-void 
+void
 Object::Dispose (void)
 {
   /**
    * Note: the code here is a bit tricky because we need to protect ourselves from
    * modifications in the aggregate array while DoDispose is called. The user's
-   * DoDispose implementation could call GetObject (which could reorder the array) 
+   * DoDispose implementation could call GetObject (which could reorder the array)
    * and it could call AggregateObject which would add an object at the end of the array.
    * So, to be safe, we restart the iteration over the array whenever we call some
    * user code.
@@ -239,16 +239,16 @@
 Object::UpdateSortedArray (struct Aggregates *aggregates, uint32_t j) const
 {
   NS_LOG_FUNCTION (this << aggregates << j);
-  while (j > 0 && 
-         aggregates->buffer[j]->m_getObjectCount > aggregates->buffer[j-1]->m_getObjectCount)
+  while (j > 0
+         && aggregates->buffer[j]->m_getObjectCount > aggregates->buffer[j - 1]->m_getObjectCount)
     {
-      Object *tmp = aggregates->buffer[j-1];
-      aggregates->buffer[j-1] = aggregates->buffer[j];
+      Object *tmp = aggregates->buffer[j - 1];
+      aggregates->buffer[j - 1] = aggregates->buffer[j];
       aggregates->buffer[j] = tmp;
       j--;
     }
 }
-void 
+void
 Object::AggregateObject (Ptr<Object> o)
 {
   NS_LOG_FUNCTION (this << o);
@@ -260,19 +260,19 @@
   Object *other = PeekPointer (o);
   // first create the new aggregate buffer.
   uint32_t total = m_aggregates->n + other->m_aggregates->n;
-  struct Aggregates *aggregates = 
-    (struct Aggregates *)std::malloc (sizeof(struct Aggregates)+(total-1)*sizeof(Object*));
+  struct Aggregates *aggregates =
+    (struct Aggregates *)std::malloc (sizeof(struct Aggregates) + (total - 1) * sizeof(Object*));
   aggregates->n = total;
 
   // copy our buffer to the new buffer
-  std::memcpy (&aggregates->buffer[0], 
-          &m_aggregates->buffer[0], 
-          m_aggregates->n*sizeof(Object*));
+  std::memcpy (&aggregates->buffer[0],
+               &m_aggregates->buffer[0],
+               m_aggregates->n * sizeof(Object*));
 
   // append the other buffer into the new buffer too
   for (uint32_t i = 0; i < other->m_aggregates->n; i++)
     {
-      aggregates->buffer[m_aggregates->n+i] = other->m_aggregates->buffer[i];
+      aggregates->buffer[m_aggregates->n + i] = other->m_aggregates->buffer[i];
       const TypeId typeId = other->m_aggregates->buffer[i]->GetInstanceTypeId ();
       if (DoGetObject (typeId))
         {
@@ -299,7 +299,7 @@
 
   // Finally, call NotifyNewAggregate on all the objects aggregates together.
   // We purposely use the old aggregate buffers to iterate over the objects
-  // because this allows us to assume that they will not change from under 
+  // because this allows us to assume that they will not change from under
   // our feet, even if our users call AggregateObject from within their
   // NotifyNewAggregate method.
   for (uint32_t i = 0; i < a->n; i++)
@@ -327,14 +327,14 @@
   NS_LOG_FUNCTION (this);
 }
 
-Object::AggregateIterator 
+Object::AggregateIterator
 Object::GetAggregateIterator (void) const
 {
   NS_LOG_FUNCTION (this);
   return AggregateIterator (this);
 }
 
-void 
+void
 Object::SetTypeId (TypeId tid)
 {
   NS_LOG_FUNCTION (this << tid);
@@ -356,7 +356,7 @@
   NS_ASSERT (!m_initialized);
 }
 
-bool 
+bool
 Object::Check (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -370,7 +370,7 @@
  * manipulating an object with a refcount of zero.  So, instead we
  * check the aggregate reference count.
  */
-bool 
+bool
 Object::CheckLoose (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -401,7 +401,7 @@
         }
     }
 
-  // Now, we know that we are alone to use this aggregate so, 
+  // Now, we know that we are alone to use this aggregate so,
   // we can dispose and delete everything safely.
 
   uint32_t n = m_aggregates->n;
@@ -421,7 +421,7 @@
     {
       // There is a trick here: each time we call delete below,
       // the deleted object is removed from the aggregate buffer
-      // in the destructor so, the index of the next element to 
+      // in the destructor so, the index of the next element to
       // lookup is always zero
       Object *current = aggregates->buffer[0];
       delete current;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/object-factory.h ns-3.31/src/core/model/object-factory.h
--- ns-3.30.1/src/core/model/object-factory.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/object-factory.h	2020-06-27 17:38:30.000000000 -0700
@@ -71,9 +71,9 @@
   void SetTypeId (const char *tid);
   void SetTypeId (std::string tid);
   /**@}*/
-  
+
   /**
-   * Check if the ObjectFactory has been configured with a TypeId 
+   * Check if the ObjectFactory has been configured with a TypeId
    *
    * \return true if a TypeId has been configured to the ObjectFactory
    */
@@ -142,7 +142,7 @@
    * The list of attributes and values to be used in constructing
    * objects by this factory.
    */
-  AttributeConstructionList m_parameters;  
+  AttributeConstructionList m_parameters;
 };
 
 std::ostream & operator << (std::ostream &os, const ObjectFactory &factory);
@@ -175,18 +175,17 @@
  * \returns A pointer to a newly allocated object.
  */
 template <typename T>
-Ptr<T> 
-CreateObjectWithAttributes
-  (std::string n1 = "", const AttributeValue & v1 = EmptyAttributeValue (),
-   std::string n2 = "", const AttributeValue & v2 = EmptyAttributeValue (),
-   std::string n3 = "", const AttributeValue & v3 = EmptyAttributeValue (),
-   std::string n4 = "", const AttributeValue & v4 = EmptyAttributeValue (),
-   std::string n5 = "", const AttributeValue & v5 = EmptyAttributeValue (),
-   std::string n6 = "", const AttributeValue & v6 = EmptyAttributeValue (),
-   std::string n7 = "", const AttributeValue & v7 = EmptyAttributeValue (),
-   std::string n8 = "", const AttributeValue & v8 = EmptyAttributeValue (),
-   std::string n9 = "", const AttributeValue & v9 = EmptyAttributeValue ()
-   );
+Ptr<T>
+CreateObjectWithAttributes (std::string n1 = "", const AttributeValue & v1 = EmptyAttributeValue (),
+                            std::string n2 = "", const AttributeValue & v2 = EmptyAttributeValue (),
+                            std::string n3 = "", const AttributeValue & v3 = EmptyAttributeValue (),
+                            std::string n4 = "", const AttributeValue & v4 = EmptyAttributeValue (),
+                            std::string n5 = "", const AttributeValue & v5 = EmptyAttributeValue (),
+                            std::string n6 = "", const AttributeValue & v6 = EmptyAttributeValue (),
+                            std::string n7 = "", const AttributeValue & v7 = EmptyAttributeValue (),
+                            std::string n8 = "", const AttributeValue & v8 = EmptyAttributeValue (),
+                            std::string n9 = "", const AttributeValue & v9 = EmptyAttributeValue ()
+                            );
 
 
 ATTRIBUTE_HELPER_HEADER (ObjectFactory);
@@ -201,7 +200,7 @@
 namespace ns3 {
 
 template <typename T>
-Ptr<T> 
+Ptr<T>
 ObjectFactory::Create (void) const
 {
   Ptr<Object> object = Create ();
@@ -209,7 +208,7 @@
 }
 
 template <typename T>
-Ptr<T> 
+Ptr<T>
 CreateObjectWithAttributes (std::string n1, const AttributeValue & v1,
                             std::string n2, const AttributeValue & v2,
                             std::string n3, const AttributeValue & v3,
@@ -222,15 +221,15 @@
 {
   ObjectFactory factory;
   factory.SetTypeId (T::GetTypeId ());
-  factory.Set(n1, v1);
-  factory.Set(n2, v2);
-  factory.Set(n3, v3);
-  factory.Set(n4, v4);
-  factory.Set(n5, v5);
-  factory.Set(n6, v6);
-  factory.Set(n7, v7);
-  factory.Set(n8, v8);
-  factory.Set(n9, v9);
+  factory.Set (n1, v1);
+  factory.Set (n2, v2);
+  factory.Set (n3, v3);
+  factory.Set (n4, v4);
+  factory.Set (n5, v5);
+  factory.Set (n6, v6);
+  factory.Set (n7, v7);
+  factory.Set (n8, v8);
+  factory.Set (n9, v9);
   return factory.Create<T> ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/object.h ns-3.31/src/core/model/object.h
--- ns-3.30.1/src/core/model/object.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/object.h	2020-06-27 17:38:30.000000000 -0700
@@ -49,7 +49,7 @@
  * \defgroup object Object
  * \brief Base classes which provide memory management and object aggregation.
  */
-  
+
 /**
  * \ingroup object
  * \ingroup ptr
@@ -97,13 +97,13 @@
    * \brief Iterate over the Objects aggregated to an ns3::Object.
    *
    * This iterator does not allow you to iterate over the parent
-   * Object used to call Object::GetAggregateIterator. 
+   * Object used to call Object::GetAggregateIterator.
    *
    * \note This is a java-style iterator.
    */
   class AggregateIterator
   {
-public:
+  public:
     /** Default constructor, which has no Object. */
     AggregateIterator ();
 
@@ -121,7 +121,9 @@
      * \returns The next aggregated Object.
      */
     Ptr<const Object> Next (void);
-private:
+
+  private:
+    /** Object needs access. */
     friend class Object;
     /**
      * Construct from an Object.
@@ -144,19 +146,23 @@
   virtual TypeId GetInstanceTypeId (void) const;
 
   /**
-   * Get a pointer to the requested aggregated Object.
+   * Get a pointer to the requested aggregated Object.  If the type of object
+   * requested is ns3::Object, a Ptr to the calling object is returned.
    *
+   * \tparam T \explicit The type of the aggregated Object to retrieve.
    * \returns A pointer to the requested Object, or zero
    *          if it could not be found.
    */
   template <typename T>
   inline Ptr<T> GetObject (void) const;
   /**
-   * Get a pointer to the requested aggregated Object by TypeId.
-   * 
+   * Get a pointer to the requested aggregated Object by TypeId.  If the
+   * TypeId argument is ns3::Object, a Ptr to the calling object is returned.
+   *
+   * \tparam T \explicit The type of the aggregated Object to retrieve.
    * \param [in] tid The TypeId of the requested Object.
-   * \returns A pointer to the requested Object, or zero
-   *          if it could not be found.
+   * \returns A pointer to the requested Object with the specified TypeId,
+   *          or zero if it could not be found.
    */
   template <typename T>
   Ptr<T> GetObject (TypeId tid) const;
@@ -164,7 +170,7 @@
    * Dispose of this Object.
    *
    * Run the DoDispose() methods of this Object and all the
-   * Objects aggregated to it.  
+   * Objects aggregated to it.
    * After calling this method, this Object is expected to be
    * totally unusable except for the Ref() and Unref() methods.
    *
@@ -182,7 +188,7 @@
    *
    * This method aggregates the two Objects together: after this
    * method returns, it becomes possible to call GetObject()
-   * on one to get the other, and vice-versa. 
+   * on one to get the other, and vice-versa.
    *
    * This method calls the virtual method NotifyNewAggregates() to
    * notify all aggregated Objects that they have been aggregated
@@ -219,7 +225,8 @@
   /**
    * Check if the object has been initialized.
    *
-   * \brief returns true if the object has been initialized. 
+   * \brief Check if the object has been initialized.
+   * \returns \c true if the object has been initialized.
    */
   bool IsInitialized (void) const;
 
@@ -253,7 +260,7 @@
   /**
    * Destructor implementation.
    *
-   * This method is called by Dispose() or by the Object's 
+   * This method is called by Dispose() or by the Object's
    * destructor, whichever comes first.
    *
    * Subclasses are expected to implement their real destruction
@@ -287,12 +294,13 @@
    * valid state.
    */
   Object (const Object &o);
-  
+
 private:
 
   /**
    * Copy an Object.
    *
+   * \tparam T \deduced The type of the Object being copied.
    * \param [in] object A pointer to the object to copy.
    * \returns A copy of the input object.
    *
@@ -305,25 +313,27 @@
   template <typename T>
   friend Ptr<T> CopyObject (Ptr<const T> object);
   /**@}*/
-  
+
   /**
    * Set the TypeId and construct all Attributes of an Object.
    *
-   * \tparam T \explicit The type of the derived object we are constructing.
+   * \tparam T \deduced The type of the Object to complete.
    * \param [in] object The uninitialized object pointer.
    * \return The derived object.
    */
   template <typename T>
   friend Ptr<T> CompleteConstruct (T *object);
 
+  /** Friends. @{*/
   friend class ObjectFactory;
   friend class AggregateIterator;
   friend struct ObjectDeleter;
+  /**@}*/
 
   /**
    * The list of Objects aggregated to this one.
    *
-   * This data structure uses a classic C-style trick to 
+   * This data structure uses a classic C-style trick to
    * hold an array of variable size without performing
    * two memory allocations: the declaration of the structure
    * declares a one-element array but when we allocate
@@ -332,7 +342,8 @@
    * variable sized buffer whose size is indicated by the element
    * \c n
    */
-  struct Aggregates {
+  struct Aggregates
+  {
     /** The number of entries in \c buffer. */
     uint32_t n;
     /** The array of Objects. */
@@ -366,7 +377,7 @@
   bool CheckLoose (void) const;
   /**
    * Set the TypeId of this Object.
-   
+
    * \param [in] tid The TypeId value to set.
    *
    * Invoked from ns3::CreateObject only.
@@ -396,7 +407,7 @@
   /**
    * Attempt to delete this Object.
    *
-   * This method iterates over all aggregated Objects to check if they all 
+   * This method iterates over all aggregated Objects to check if they all
    * have a zero refcount. If yes, the Object and all
    * its aggregates are deleted. If not, nothing is done.
    */
@@ -419,7 +430,7 @@
   /**
    * A pointer to an array of 'aggregates'.
    *
-   * A pointer to each Object aggregated to this Object is stored in this 
+   * A pointer to each Object aggregated to this Object is stored in this
    * array.  The array is shared by all aggregated Objects
    * so the size of the array is indirectly a reference count.
    */
@@ -448,14 +459,14 @@
  *   The Object implementation which depends on templates
  *************************************************************************/
 
-void 
+void
 ObjectDeleter::Delete (Object *object)
 {
   object->DoDelete ();
 }
 
 template <typename T>
-Ptr<T> 
+Ptr<T>
 Object::GetObject () const
 {
   // This is an optimization: if the cast works (which is likely),
@@ -474,8 +485,16 @@
   return 0;
 }
 
+template
+<>
+inline Ptr<Object>
+Object::GetObject () const
+{
+  return Ptr<Object> (const_cast<Object *> (this));
+}
+
 template <typename T>
-Ptr<T> 
+Ptr<T>
 Object::GetObject (TypeId tid) const
 {
   Ptr<Object> found = DoGetObject (tid);
@@ -486,6 +505,21 @@
   return 0;
 }
 
+template
+<>
+inline Ptr<Object>
+Object::GetObject (TypeId tid) const
+{
+  if (tid == Object::GetTypeId ())
+    {
+      return Ptr<Object> (const_cast<Object *> (this));
+    }
+  else
+    {
+      return DoGetObject (tid);
+    }
+}
+
 /*************************************************************************
  *   The helper functions which need templates.
  *************************************************************************/
@@ -514,7 +548,7 @@
   return Ptr<T> (object, false);
 }
 
-/** 
+/**
  * \ingroup object
  * @{
  */
@@ -522,144 +556,13 @@
  * Create an object by type, with varying number of constructor parameters.
  *
  * \tparam T \explicit The type of the derived object to construct.
+ * \param [in] args Arguments to pass to the constructor.
  * \return The derived object.
  */
-template <typename T>
-Ptr<T> CreateObject (void)
-{
-  return CompleteConstruct (new T ());
-}
-/**
- * \copybrief CreateObject()
- * \tparam T \explicit The type of the derived object to construct.
- * \tparam T1 \deduced The type of the constructor argument.
- * \param [in] a1 The constructor argument
- * \return The derived object.
- */
-template <typename T, typename T1>
-Ptr<T> CreateObject (T1 a1)
-{
-  return CompleteConstruct (new T (a1));
-}
-
-/**
- * \copybrief CreateObject()
- * \tparam T \explicit The type of the derived object to construct.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \param [in] a1 The constructor first argument
- * \param [in] a2 The constructor second argument
- * \return The derived object.
- */
-template <typename T, typename T1, typename T2>
-Ptr<T> CreateObject (T1 a1, T2 a2)
-{
-  return CompleteConstruct (new T (a1,a2));
-}
-
-/**
- * \copybrief CreateObject()
- * \tparam T \explicit The type of the derived object to construct.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \param [in] a1 The constructor first argument
- * \param [in] a2 The constructor second argument
- * \param [in] a3 The constructor third argument
- * \return The derived object.
- */
-template <typename T, typename T1, typename T2, typename T3>
-Ptr<T> CreateObject (T1 a1, T2 a2, T3 a3)
-{
-  return CompleteConstruct (new T (a1,a2,a3));
-}
-
-/**
- * \copybrief CreateObject()
- * \tparam T \explicit The type of the derived object to construct.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \param [in] a1 The constructor first argument
- * \param [in] a2 The constructor second argument
- * \param [in] a3 The constructor third argument
- * \param [in] a4 The constructor fourth argument
- * \return The derived object.
- */
-template <typename T, typename T1, typename T2, typename T3, typename T4>
-Ptr<T> CreateObject (T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  return CompleteConstruct (new T (a1,a2,a3,a4));
-}
-
-/**
- * \copybrief CreateObject()
- * \tparam T \explicit The type of the derived object to construct.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \tparam T5 \deduced The type of the fifth constructor argument.
- * \param [in] a1 The constructor first argument
- * \param [in] a2 The constructor second argument
- * \param [in] a3 The constructor third argument
- * \param [in] a4 The constructor fourth argument
- * \param [in] a5 The constructor fifth argument
- * \return The derived object.
- */
-template <typename T, typename T1, typename T2, typename T3, typename T4, typename T5>
-Ptr<T> CreateObject (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-  return CompleteConstruct (new T (a1,a2,a3,a4,a5));
-}
-
-/**
- * \copybrief CreateObject()
- * \tparam T \explicit The type of the derived object to construct.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \tparam T5 \deduced The type of the fifth constructor argument.
- * \tparam T6 \deduced The type of the sixth constructor argument.
- * \param [in] a1 The constructor first argument
- * \param [in] a2 The constructor second argument
- * \param [in] a3 The constructor third argument
- * \param [in] a4 The constructor fourth argument
- * \param [in] a5 The constructor fifth argument
- * \param [in] a6 The constructor sixth argument
- * \return The derived object.
- */
-template <typename T, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-Ptr<T> CreateObject (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
-{
-  return CompleteConstruct (new T (a1,a2,a3,a4,a5,a6));
-}
-
-/**
- * \copybrief CreateObject()
- * \tparam T \explicit The type of the derived object to construct.
- * \tparam T1 \deduced The type of the first constructor argument.
- * \tparam T2 \deduced The type of the second constructor argument.
- * \tparam T3 \deduced The type of the third constructor argument.
- * \tparam T4 \deduced The type of the fourth constructor argument.
- * \tparam T5 \deduced The type of the fifth constructor argument.
- * \tparam T6 \deduced The type of the sixth constructor argument.
- * \tparam T7 \deduced The type of the seventh constructor argument.
- * \param [in] a1 The constructor first argument
- * \param [in] a2 The constructor second argument
- * \param [in] a3 The constructor third argument
- * \param [in] a4 The constructor fourth argument
- * \param [in] a5 The constructor fifth argument
- * \param [in] a6 The constructor sixth argument
- * \param [in] a7 The constructor seventh argument
- * \return The derived object.
- */
-template <typename T, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
-Ptr<T> CreateObject (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6, T7 a7)
+template <typename T, typename... Args>
+Ptr<T> CreateObject (Args&&... args)
 {
-  return CompleteConstruct (new T (a1,a2,a3,a4,a5,a6,a7));
+  return CompleteConstruct (new T (std::forward<Args> (args)...));
 }
 /**@}*/
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/object-map.h ns-3.31/src/core/model/object-map.h
--- ns-3.30.1/src/core/model/object-map.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/object-map.h	2020-06-27 17:38:30.000000000 -0700
@@ -59,7 +59,7 @@
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectMapAccessor (Ptr<U> (T::*get)(INDEX) const,
-                          INDEX (T::*getN)(void) const);
+                       INDEX (T::*getN)(void) const);
 
 /**
  * \ingroup attribute_ObjectMap
@@ -81,7 +81,8 @@
 {
   struct MemberStdContainer : public ObjectPtrContainerAccessor
   {
-    virtual bool DoGetN (const ObjectBase *object, std::size_t *n) const {
+    virtual bool DoGetN (const ObjectBase *object, std::size_t *n) const
+    {
       const T *obj = dynamic_cast<const T *> (object);
       if (obj == 0)
         {
@@ -90,7 +91,8 @@
       *n = (obj->*m_memberVector).size ();
       return true;
     }
-    virtual Ptr<Object> DoGet(const ObjectBase *object, std::size_t i, std::size_t *index) const {
+    virtual Ptr<Object> DoGet (const ObjectBase *object, std::size_t i, std::size_t *index) const
+    {
       const T *obj = static_cast<const T *> (object);
       typename U::const_iterator begin = (obj->*m_memberVector).begin ();
       typename U::const_iterator end = (obj->*m_memberVector).end ();
@@ -123,17 +125,17 @@
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectMapAccessor (Ptr<U> (T::*get)(INDEX) const,
-		       INDEX (T::*getN)(void) const)
+                       INDEX (T::*getN)(void) const)
 {
-  return MakeObjectPtrContainerAccessor<T,U,INDEX>(get, getN);
+  return MakeObjectPtrContainerAccessor<T,U,INDEX> (get, getN);
 }
 
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectMapAccessor (INDEX (T::*getN)(void) const,
-		       Ptr<U> (T::*get)(INDEX) const)
+                       Ptr<U> (T::*get)(INDEX) const)
 {
-  return MakeObjectPtrContainerAccessor<T,U,INDEX>(get, getN);
+  return MakeObjectPtrContainerAccessor<T,U,INDEX> (get, getN);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/object-ptr-container.h ns-3.31/src/core/model/object-ptr-container.h
--- ns-3.30.1/src/core/model/object-ptr-container.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/object-ptr-container.h	2020-06-27 17:38:30.000000000 -0700
@@ -36,7 +36,7 @@
 
 /**
  * \ingroup attribute_ObjectPtrContainer
- * 
+ *
  * \brief Container for a set of ns3::Object pointers.
  *
  * This class it used to get attribute access to an array of
@@ -102,6 +102,7 @@
   virtual bool DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker);
 
 private:
+  /** ObjectPtrContainerAccessor::Get() needs access. */
   friend class ObjectPtrContainerAccessor;
   /** The container implementation. */
   std::map<std::size_t, Ptr<Object> > m_objects;
@@ -125,7 +126,7 @@
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectPtrContainerAccessor (Ptr<U> (T::*get)(INDEX) const,
-				INDEX (T::*getN)(void) const);
+                                INDEX (T::*getN)(void) const);
 
 /**
  * \ingroup attribute_ObjectPtrContainer
@@ -145,7 +146,7 @@
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectPtrContainerAccessor (INDEX (T::*getN)(void) const,
-				Ptr<U> (T::*get)(INDEX) const);
+                                Ptr<U> (T::*get)(INDEX) const);
 
 class ObjectPtrContainerChecker : public AttributeChecker
 {
@@ -176,25 +177,32 @@
 class ObjectPtrContainerChecker : public ns3::ObjectPtrContainerChecker
 {
 public:
-  virtual TypeId GetItemTypeId (void) const {
+  virtual TypeId GetItemTypeId (void) const
+  {
     return T::GetTypeId ();
   }
-  virtual bool Check (const AttributeValue &value) const {
+  virtual bool Check (const AttributeValue &value) const
+  {
     return dynamic_cast<const ObjectPtrContainerValue *> (&value) != 0;
   }
-  virtual std::string GetValueTypeName (void) const {
+  virtual std::string GetValueTypeName (void) const
+  {
     return "ns3::ObjectPtrContainerValue";
   }
-  virtual bool HasUnderlyingTypeInformation (void) const {
+  virtual bool HasUnderlyingTypeInformation (void) const
+  {
     return true;
   }
-  virtual std::string GetUnderlyingTypeInformation (void) const {
+  virtual std::string GetUnderlyingTypeInformation (void) const
+  {
     return "ns3::Ptr< " + T::GetTypeId ().GetName () + " >";
   }
-  virtual Ptr<AttributeValue> Create (void) const {
+  virtual Ptr<AttributeValue> Create (void) const
+  {
     return ns3::Create<ObjectPtrContainerValue> ();
   }
-  virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const {
+  virtual bool Copy (const AttributeValue &source, AttributeValue &destination) const
+  {
     const ObjectPtrContainerValue *src = dynamic_cast<const ObjectPtrContainerValue *> (&source);
     ObjectPtrContainerValue *dst = dynamic_cast<ObjectPtrContainerValue *> (&destination);
     if (src == 0 || dst == 0)
@@ -208,7 +216,7 @@
 
 } // namespace internal
 
-  
+
 /**
  * \ingroup attribute_ObjectPtrContainer
  * AttributeAccessor implementation for ObjectPtrContainerValue.
@@ -220,6 +228,7 @@
   virtual bool Get (const ObjectBase * object, AttributeValue &value) const;
   virtual bool HasGetter (void) const;
   virtual bool HasSetter (void) const;
+
 private:
   /**
    * Get the number of instances in the container.
@@ -228,7 +237,7 @@
    * \param [out] n The number of instances in the container.
    * \returns true if the value could be obtained successfully.
    */
-  virtual bool DoGetN(const ObjectBase *object, std::size_t *n) const = 0;
+  virtual bool DoGetN (const ObjectBase *object, std::size_t *n) const = 0;
   /**
    * Get an instance from the container, identified by index.
    *
@@ -237,17 +246,18 @@
    * \param [out] index The index retrieved.
    * \returns The index requested.
    */
-  virtual Ptr<Object> DoGet(const ObjectBase *object, std::size_t i, std::size_t *index) const = 0;
+  virtual Ptr<Object> DoGet (const ObjectBase *object, std::size_t i, std::size_t *index) const = 0;
 };
 
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectPtrContainerAccessor (Ptr<U> (T::*get)(INDEX) const,
-				INDEX (T::*getN)(void) const)
+                                INDEX (T::*getN)(void) const)
 {
   struct MemberGetters : public ObjectPtrContainerAccessor
   {
-    virtual bool DoGetN(const ObjectBase *object, std::size_t *n) const {
+    virtual bool DoGetN (const ObjectBase *object, std::size_t *n) const
+    {
       const T *obj = dynamic_cast<const T *> (object);
       if (obj == 0)
         {
@@ -256,7 +266,8 @@
       *n = (obj->*m_getN)();
       return true;
     }
-    virtual Ptr<Object> DoGet(const ObjectBase *object, std::size_t i, std::size_t *index) const {
+    virtual Ptr<Object> DoGet (const ObjectBase *object, std::size_t i, std::size_t *index) const
+    {
       const T *obj = static_cast<const T *> (object);
       *index = i;
       return (obj->*m_get)(i);
@@ -272,7 +283,7 @@
 template <typename T, typename U, typename INDEX>
 Ptr<const AttributeAccessor>
 MakeObjectPtrContainerAccessor (INDEX (T::*getN)(void) const,
-				Ptr<U> (T::*get)(INDEX) const)
+                                Ptr<U> (T::*get)(INDEX) const)
 {
   return MakeObjectPtrContainerAccessor (get, getN);
 }
